  MEMBER

_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

    MAP
DoPrimeAutoInc PROCEDURE(SAIFileManager SELF, BYTE HandleErrors),BYTE,PRIVATE
SetThread      PROCEDURE(SAIFileManager SELF),PRIVATE
    END

    INCLUDE('SAIFILE.INC'),ONCE


DoneThreadQueue   QUEUE,TYPE         ! QUEUE of status of all file buffers
Id                  SIGNED           ! Thread number
AutoIncDone         BYTE             ! Auto-increment done or not flag
                  END

SAIFileManager.Construct PROCEDURE()
  CODE
    SELF.Done &= NEW DoneThreadQueue

SAIFileManager.Destruct PROCEDURE()
  CODE
    DISPOSE(SELF.Done)

SAIFileManager.PrimeAutoInc PROCEDURE
  CODE
    IF SELF.HasServerAutoInc
      RETURN SELF.DoPrimeAutoInc(1)
    ELSE
      RETURN PARENT.PrimeAutoInc()
    END

SAIFileManager.TryPrimeAutoInc PROCEDURE
  CODE
    IF SELF.HasServerAutoInc
      RETURN SELF.DoPrimeAutoInc(0)
    ELSE
      RETURN PARENT.TryPrimeAutoInc()
    END

SAIFileManager.DoPrimeAutoInc PROCEDURE(BYTE HandleErrors)
I SHORT,AUTO
  CODE
    IF SELF.UseFile() THEN RETURN Level:Fatal.
    SELF.SetThread
    IF SELF.Done.AutoIncDone
      RETURN Level:Benign
    END
    ASSERT(NOT SELF.AutoIncField &= NULL)
    ADD(SELF.File)
    IF ERRORCODE()
      SELF.SetError(Msg:AddFailed)
      IF HandleErrors
        RETURN SELF.Throw()
      ELSE
        RETURN Level:Notify
      END
    ELSE
      IF SELF.TryGetAutoIncValue()
        SELF.SetError(Msg:AbortReading)
        IF HandleErrors
          RETURN SELF.Throw()
        ELSE
          RETURN Level:Notify
        END
      END
    END
    SELF.Done.AutoIncDone = TRUE
    PUT(SELF.Done)
    ASSERT(~ERRORCODE())
    RETURN Level:Benign

SAIFileManager.CancelAutoInc PROCEDURE(<RelationManager RM>)
  CODE
    IF SELF.HasServerAutoInc
      SELF.SetThread
      SELF.Done.AutoIncDone = FALSE
      PUT(SELF.Done)
      ASSERT(~ERRORCODE())
      GET(SELF.File,SELF.AutoIncKey)
      ASSERT(~ERRORCODE())
      DELETE(SELF.File)
      ASSERT(~ERRORCODE())
      RETURN Level:Benign
    ELSE
      RETURN PARENT.CancelAutoInc(RM)
    END

SAIFileManager.Insert     PROCEDURE
ret BYTE,AUTO
  CODE
    ret = PARENT.Insert()
    SELF.SetThread
    SELF.Done.AutoIncDone = FALSE
    PUT(SELF.Done)
    ASSERT(~ERRORCODE())
    RETURN ret

SAIFileManager.TryInsert  PROCEDURE
ret BYTE,AUTO
  CODE
    ret = PARENT.TryInsert()
    SELF.SetThread
    SELF.Done.AutoIncDone = FALSE
    PUT(SELF.Done)
    ASSERT(~ERRORCODE())
    RETURN ret

SAIFileManager.TryGetAutoIncValue PROCEDURE()
  CODE
    ASSERT(0)
    RETURN Level:Fatal

SAIFileManager.SetThread PROCEDURE
ThisThread SIGNED(1)
  CODE
    IF SELF.File{PROP:Thread}
      ThisThread = THREAD()
    END
    ASSERT(~(SELF.Done &= NULL))
    SELF.Done.Id = ThisThread
    GET(SELF.Done,SELF.Done.Id)
    IF ERRORCODE()
      CLEAR(SELF.Done)
      SELF.Done.Id = ThisThread
      ADD(SELF.Done,SELF.Done.Id)
      ASSERT(~ERRORCODE())
    END
    ASSERT(NOT SELF.File &= NULL)
